## yquake2 7.21+ctf1.05~dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0 FATAL_ERROR)

# Enforce "Debug" as standard build type
if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# CMake project configuration
project(yquake2)

# Cmake module search path
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/stuff/cmake/modules ${CMAKE_MODULE_PATH})

if(YQUAKE2LIBS)
	if(CMAKE_CROSSCOMPILING)
		set(CMAKE_FIND_ROOT_PATH ${YQUAKE2LIBS})
	else()
		set(ENV{CMAKE_PREFIX_PATH} ${YQUAKE2LIBS})
	endif()

	set(ENV{OPENALDIR} ${YQUAKE2LIBS})
	set(ENV{SDLDIR} ${YQUAKE2LIBS})
	set(ENV{SDL2DIR} ${YQUAKE2LIBS})
endif()

# Add extended path for FreeBSD and Homebrew on OS X
list(APPEND CMAKE_PREFIX_PATH /usr/local)

# Enforce compiler flags (GCC / Clang compatible, yquake2
# won't build with another compiler anyways)
#  -Wall                -> More warnings
#  -fno-strict-aliasing -> Quake 2 is far away from strict aliasing
#  -fwrapv              -> Make signed integer overflows defined
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -fno-strict-aliasing -fwrapv")

# Use -O2 as maximum optimization level. -O3 has it's problems with yquake2.
string(REPLACE "-O3" "-O2" CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")

# yquake2 compilation options
option(ZIP_SUPPORT "ZIP support" ON)
option(OGG_SUPPORT "OGG Vorbis playback support (Music)" ON)
option(OPENAL_SUPPORT "OpenAL support" ON)
option(SYSTEMWIDE_SUPPORT "Enable systemwide installation of game assets" OFF)

# These variables will act as our list of include folders and linker flags
set(yquake2IncludeDirectories)
set(yquake2LinkerDirectories)
set(yquake2LinkerFlags)
set(yquake2ClientLinkerFlags)
set(yquake2ServerLinkerFlags)
set(yquake2OpenGLLinkerFlags)
set(yquake2SDLLinkerFlags)
set(yquake2ZLibLinkerFlags)

# Set directory locations (allowing us to move directories easily)
set(SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR}/src)
set(BACKENDS_SRC_DIR ${SOURCE_DIR}/backends)
set(COMMON_SRC_DIR ${SOURCE_DIR}/common)
set(GAME_SRC_DIR ${SOURCE_DIR}/game)
set(SERVER_SRC_DIR ${SOURCE_DIR}/server)
set(CLIENT_SRC_DIR ${SOURCE_DIR}/client)
set(REF_SRC_DIR ${SOURCE_DIR}/client/refresh)

# Operating system
set(YQ2OSTYPE "${CMAKE_SYSTEM_NAME}" CACHE STRING "Override operation system type")
add_definitions(-DYQ2OSTYPE="${YQ2OSTYPE}")

# Architecture string
set(YQ2ARCH "${CMAKE_SYSTEM_PROCESSOR}" CACHE STRING "Override CPU architecture")
string(REGEX REPLACE "amd64" "x86_64" ARCH ${YQ2ARCH})
string(REGEX REPLACE "i.86" "i386" ARCH ${ARCH})
string(REGEX REPLACE "^arm.*" "arm" ARCH ${ARCH})
add_definitions(-DYQ2ARCH="${ARCH}")

# Systemwide installation of game assets
if(${SYSTEMWIDE_SUPPORT})
    add_definitions(-DSYSTEMWIDE)
endif()

# Required libraries to build the different components of the binaries. Find
# them and add the include/linker directories and flags (in case the package
# manager find it in a weird place)
find_package(SDL2)
if(${SDL2_FOUND})
	add_definitions(-DSDL2)
	list(APPEND yquake2IncludeDirectories "${SDL2_INCLUDE_DIR}/..")
	list(APPEND yquake2SDLLinkerFlags ${SDL2_LIBRARY})
else()
	find_package(SDL REQUIRED)
	add_definitions(-DWITH_CDA)
	list(APPEND yquake2IncludeDirectories "${SDL_INCLUDE_DIR}/..")
	list(APPEND yquake2SDLLinkerFlags ${SDL_LIBRARY})
endif()

find_package(OpenGL REQUIRED)
list(APPEND yquake2IncludeDirectories ${OPENGL_INCLUDE_DIR})
list(APPEND yquake2OpenGLLinkerFlags ${OPENGL_LIBRARIES})

if(${CMAKE_HOST_SYSTEM_NAME} STREQUAL "FreeBSD")
	find_library(EXECINFO_LIBRARIES execinfo /usr/lib /usr/local/lib)
	list(APPEND yquake2ClientLinkerFlags ${EXECINFO_LIBRARIES})
	list(APPEND yquake2ServerLinkerFlags ${EXECINFO_LIBRARIES})
endif()



if(${ZIP_SUPPORT})
	find_package(ZLIB REQUIRED)
	list(APPEND yquake2IncludeDirectories ${ZLIB_INCLUDE_DIRS})
	list(APPEND yquake2ZLibLinkerFlags ${ZLIB_LIBRARIES})
	add_definitions(-DZIP -DNOUNCRYPT)

	if(NOT CMAKE_SYSTEM_NAME MATCHES "Linux" OR NOT CMAKE_SYSTEM_NAME MATCHES "Windows")
		add_definitions(-DIOAPI_NO_64)
	endif()
endif()

if(${OGG_SUPPORT})
	find_package(OggVorbis)
	if(${OGGVORBIS_FOUND})
		add_definitions(-DOGG)
		list(APPEND yquake2IncludeDirectories ${VORBIS_INCLUDE_DIR})
		list(APPEND yquake2ClientLinkerFlags ${OGG_LIBRARY} ${VORBIS_LIBRARY} ${VORBISFILE_LIBRARY})
	endif()
endif()

if(${OPENAL_SUPPORT})
	find_package(OpenAL)

	# TODO: OS X is still missing here
	if(${OPENAL_FOUND} AND NOT(${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
		list(APPEND yquake2IncludeDirectories "${OPENAL_INCLUDE_DIR}")
		list(APPEND yquake2ClientLinkerFlags ${OPENAL_LIBRARY})

		if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
			add_definitions(-DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER="openal32.dll")
		elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
			add_definitions(-DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER="libopenal.dylib")
		elseif((${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD") OR (${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD"))
			add_definitions(-DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER="libopenal.so")
		else()
			add_definitions(-DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER="libopenal.so.1")
		endif()
	endif()
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
	list(APPEND yquake2LinkerFlags "-lm -static-libgcc")
else()
	list(APPEND yquake2LinkerFlags "-lm -rdynamic")
endif()

list(APPEND yquake2LinkerFlags ${CMAKE_DL_LIBS})

# With all of those libraries and user defined paths
# added, lets give them to the compiler and linker.
include_directories(${yquake2IncludeDirectories} ${CMAKE_SOURCE_DIR}/src/client/refresh/gl3/glad/include)
link_directories(${yquake2LinkerDirectories})

# If we're building with gcc for i386 let's define -ffloat-store.
# This helps the old and crappy x87 FPU to produce correct values.
# Would be nice if Clang had something comparable.
if ("${ARCH}" STREQUAL "i386")
	if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ffloat-store")
	endif()
endif()

# Force SSE math on x86_64. All sane compilers should do this
# anyway, just to protect us from broken Linux distros.
if ("${ARCH}" STREQUAL "x86_64")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mfpmath=sse")
endif()

set(Backends-Generic-Source
	${BACKENDS_SRC_DIR}/generic/misc.c
	${BACKENDS_SRC_DIR}/generic/qal.c
	${BACKENDS_SRC_DIR}/generic/vid.c

	${BACKENDS_SRC_DIR}/sdl/cd.c
	${BACKENDS_SRC_DIR}/sdl/input.c
	${BACKENDS_SRC_DIR}/sdl/refresh.c
	${BACKENDS_SRC_DIR}/sdl/sound.c
	)

set(Backends-Generic-Header
	${BACKENDS_SRC_DIR}/generic/header/input.h
	${BACKENDS_SRC_DIR}/generic/header/qal.h
	)

set(Backends-Unix-Source
	${BACKENDS_SRC_DIR}/generic/misc.c
	${BACKENDS_SRC_DIR}/unix/main.c
	${BACKENDS_SRC_DIR}/unix/network.c
	${BACKENDS_SRC_DIR}/unix/signalhandler.c
	${BACKENDS_SRC_DIR}/unix/system.c
	${BACKENDS_SRC_DIR}/unix/shared/hunk.c
	)

set(Backends-Windows-Source
	${BACKENDS_SRC_DIR}/generic/frame.c
	${BACKENDS_SRC_DIR}/windows/icon.rc
	${BACKENDS_SRC_DIR}/windows/main.c
	${BACKENDS_SRC_DIR}/windows/network.c
	${BACKENDS_SRC_DIR}/windows/system.c
	${BACKENDS_SRC_DIR}/windows/shared/hunk.c
	)

set(Backends-Windows-Header
	${BACKENDS_SRC_DIR}/windows/header/resource.h
	)

set(REF-Windows-Source
	${BACKENDS_SRC_DIR}/windows/shared/hunk.c
	)

set(REF-Unix-Source
	${BACKENDS_SRC_DIR}/unix/shared/hunk.c
	)

# Set the nessesary platform specific source
if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
	set(Platform-Specific-Source ${Backends-Windows-Source} ${Backends-Windows-Header})
	set(REF-Platform-Specific-Source ${REF-Windows-Source})
else()
	set(Platform-Specific-Source ${Backends-Unix-Source})
	set(REF-Platform-Specific-Source ${REF-Unix-Source})
endif()

set(Game-Source
	${COMMON_SRC_DIR}/shared/flash.c
	${COMMON_SRC_DIR}/shared/rand.c
	${COMMON_SRC_DIR}/shared/shared.c
	${GAME_SRC_DIR}/g_ai.c
	${GAME_SRC_DIR}/g_chase.c
	${GAME_SRC_DIR}/g_cmds.c
	${GAME_SRC_DIR}/g_combat.c
	${GAME_SRC_DIR}/g_func.c
	${GAME_SRC_DIR}/g_items.c
	${GAME_SRC_DIR}/g_main.c
	${GAME_SRC_DIR}/g_misc.c
	${GAME_SRC_DIR}/g_monster.c
	${GAME_SRC_DIR}/g_phys.c
	${GAME_SRC_DIR}/g_spawn.c
	${GAME_SRC_DIR}/g_svcmds.c
	${GAME_SRC_DIR}/g_target.c
	${GAME_SRC_DIR}/g_trigger.c
	${GAME_SRC_DIR}/g_turret.c
	${GAME_SRC_DIR}/g_utils.c
	${GAME_SRC_DIR}/g_weapon.c
	${GAME_SRC_DIR}/monster/berserker/berserker.c
	${GAME_SRC_DIR}/monster/boss2/boss2.c
	${GAME_SRC_DIR}/monster/boss3/boss3.c
	${GAME_SRC_DIR}/monster/boss3/boss31.c
	${GAME_SRC_DIR}/monster/boss3/boss32.c
	${GAME_SRC_DIR}/monster/brain/brain.c
	${GAME_SRC_DIR}/monster/chick/chick.c
	${GAME_SRC_DIR}/monster/flipper/flipper.c
	${GAME_SRC_DIR}/monster/float/float.c
	${GAME_SRC_DIR}/monster/flyer/flyer.c
	${GAME_SRC_DIR}/monster/gladiator/gladiator.c
	${GAME_SRC_DIR}/monster/gunner/gunner.c
	${GAME_SRC_DIR}/monster/hover/hover.c
	${GAME_SRC_DIR}/monster/infantry/infantry.c
	${GAME_SRC_DIR}/monster/insane/insane.c
	${GAME_SRC_DIR}/monster/medic/medic.c
	${GAME_SRC_DIR}/monster/misc/move.c
	${GAME_SRC_DIR}/monster/mutant/mutant.c
	${GAME_SRC_DIR}/monster/parasite/parasite.c
	${GAME_SRC_DIR}/monster/soldier/soldier.c
	${GAME_SRC_DIR}/monster/supertank/supertank.c
	${GAME_SRC_DIR}/monster/tank/tank.c
	${GAME_SRC_DIR}/player/client.c
	${GAME_SRC_DIR}/player/hud.c
	${GAME_SRC_DIR}/player/trail.c
	${GAME_SRC_DIR}/player/view.c
	${GAME_SRC_DIR}/player/weapon.c
	${GAME_SRC_DIR}/savegame/savegame.c
	)

set(Game-Header
	${GAME_SRC_DIR}/header/game.h
	${GAME_SRC_DIR}/header/local.h
	${GAME_SRC_DIR}/monster/berserker/berserker.h
	${GAME_SRC_DIR}/monster/boss2/boss2.h
	${GAME_SRC_DIR}/monster/boss3/boss31.h
	${GAME_SRC_DIR}/monster/boss3/boss32.h
	${GAME_SRC_DIR}/monster/brain/brain.h
	${GAME_SRC_DIR}/monster/chick/chick.h
	${GAME_SRC_DIR}/monster/flipper/flipper.h
	${GAME_SRC_DIR}/monster/float/float.h
	${GAME_SRC_DIR}/monster/flyer/flyer.h
	${GAME_SRC_DIR}/monster/gladiator/gladiator.h
	${GAME_SRC_DIR}/monster/gunner/gunner.h
	${GAME_SRC_DIR}/monster/hover/hover.h
	${GAME_SRC_DIR}/monster/infantry/infantry.h
	${GAME_SRC_DIR}/monster/insane/insane.h
	${GAME_SRC_DIR}/monster/medic/medic.h
	${GAME_SRC_DIR}/monster/misc/player.h
	${GAME_SRC_DIR}/monster/mutant/mutant.h
	${GAME_SRC_DIR}/monster/parasite/parasite.h
	${GAME_SRC_DIR}/monster/soldier/soldier.h
	${GAME_SRC_DIR}/monster/supertank/supertank.h
	${GAME_SRC_DIR}/monster/tank/tank.h
	${GAME_SRC_DIR}/savegame/tables/clientfields.h
	${GAME_SRC_DIR}/savegame/tables/fields.h
	${GAME_SRC_DIR}/savegame/tables/gamefunc_decs.h
	${GAME_SRC_DIR}/savegame/tables/gamefunc_list.h
	${GAME_SRC_DIR}/savegame/tables/gamemmove_decs.h
	${GAME_SRC_DIR}/savegame/tables/gamemmove_list.h
	${GAME_SRC_DIR}/savegame/tables/levelfields.h
	)

set(Client-Source
	${CLIENT_SRC_DIR}/cl_cin.c
	${CLIENT_SRC_DIR}/cl_console.c
	${CLIENT_SRC_DIR}/cl_download.c
	${CLIENT_SRC_DIR}/cl_effects.c
	${CLIENT_SRC_DIR}/cl_entities.c
	${CLIENT_SRC_DIR}/cl_input.c
	${CLIENT_SRC_DIR}/cl_inventory.c
	${CLIENT_SRC_DIR}/cl_keyboard.c
	${CLIENT_SRC_DIR}/cl_lights.c
	${CLIENT_SRC_DIR}/cl_main.c
	${CLIENT_SRC_DIR}/cl_network.c
	${CLIENT_SRC_DIR}/cl_parse.c
	${CLIENT_SRC_DIR}/cl_particles.c
	${CLIENT_SRC_DIR}/cl_prediction.c
	${CLIENT_SRC_DIR}/cl_screen.c
	${CLIENT_SRC_DIR}/cl_tempentities.c
	${CLIENT_SRC_DIR}/cl_view.c
	${CLIENT_SRC_DIR}/menu/menu.c
	${CLIENT_SRC_DIR}/menu/qmenu.c
	${CLIENT_SRC_DIR}/menu/videomenu.c
	${CLIENT_SRC_DIR}/sound/ogg.c
	${CLIENT_SRC_DIR}/sound/openal.c
	${CLIENT_SRC_DIR}/sound/sound.c
	${CLIENT_SRC_DIR}/sound/wave.c
	${COMMON_SRC_DIR}/argproc.c
	${COMMON_SRC_DIR}/clientserver.c
	${COMMON_SRC_DIR}/collision.c
	${COMMON_SRC_DIR}/crc.c
	${COMMON_SRC_DIR}/cmdparser.c
	${COMMON_SRC_DIR}/cvar.c
	${COMMON_SRC_DIR}/filesystem.c
	${COMMON_SRC_DIR}/glob.c
	${COMMON_SRC_DIR}/md4.c
	${COMMON_SRC_DIR}/movemsg.c
	${COMMON_SRC_DIR}/frame.c
	${COMMON_SRC_DIR}/netchan.c
	${COMMON_SRC_DIR}/pmove.c
	${COMMON_SRC_DIR}/szone.c
	${COMMON_SRC_DIR}/zone.c
	${COMMON_SRC_DIR}/shared/flash.c
	${COMMON_SRC_DIR}/shared/rand.c
	${COMMON_SRC_DIR}/shared/shared.c
	${COMMON_SRC_DIR}/unzip/ioapi.c
	${COMMON_SRC_DIR}/unzip/unzip.c
	${SERVER_SRC_DIR}/sv_cmd.c

=== Makefile ===
# ------------------------------------------------------ #
# Makefile for the "Yamagi Quake 2 Client"               #
#                                                        #
# Just type "make" to compile the                        #
#  - SDL Client (quake2)                                 #
#  - Server (q2ded)                                      #
#  - Quake II Game (baseq2)                              #
#                                                        #
# Base dependencies:                                     #
#  - SDL 1.2 or SDL 2.0                                  #
#  - libGL                                               #
#                                                        #
# Further dependencies:                                  #
#  - libogg                                              #
#  - libvorbis                                           #
#  - OpenAL                                              #
#  - zlib                                                #
#                                                        #
# Platforms:                                             #
#  - FreeBSD                                             #
#  - Linux                                               #
#  - OpenBSD                                             #
#  - OS X                                                #
#  - Windows (MinGW)                                     #
# ------------------------------------------------------ #

# User configurable options
# -------------------------

# Enables CD audio playback. CD audio playback is used
# for the background music and doesn't add any further
# dependencies. It should work on all platforms where
# CD playback is supported by SDL.
WITH_CDA:=yes

# Enables OGG/Vorbis support. OGG/Vorbis files can be
# used as a substitute of CD audio playback. Adds
# dependencies to libogg, libvorbis and libvorbisfile.
WITH_OGG:=yes

# Enables the optional OpenAL sound system.
# To use it your system needs libopenal.so.1
# or openal32.dll (we recommend openal-soft)
# installed
WITH_OPENAL:=yes

# Enables optional runtime loading of OpenAL (dlopen or
# similar). If set to "no", the library is linked in at
# compile time in the normal way. On Windows this option
# is ignored, OpenAL is always loaded at runtime.
DLOPEN_OPENAL:=yes

# Use SDL2 instead of SDL1.2. Disables CD audio support,
# because SDL2 has none. Use OGG/Vorbis music instead :-)
# On Windows sdl-config isn't used, so make sure that
# you've got the SDL2 headers and libs installed.
WITH_SDL2:=yes

# Set the gamma via X11 and not via SDL. This works
# around problems in some SDL version. Adds dependencies
# to pkg-config, libX11 and libXxf86vm. Unsupported on
# Windows and OS X.
WITH_X11GAMMA:=no

# Enables opening of ZIP files (also known as .pk3 paks).
# Adds a dependency to libz
WITH_ZIP:=yes

# Enable systemwide installation of game assets
WITH_SYSTEMWIDE:=no

# This will set the default SYSTEMDIR, a non-empty string
# would actually be used. On Windows normals slashes (/)
# instead of backslashed (\) should be used! The string
# MUST NOT be surrounded by quotation marks!
WITH_SYSTEMDIR:=""

# This will set the architectures of the OSX-binaries.
# You have to make sure your libs/frameworks supports
# these architectures! To build an universal ppc-compatible
# one would add -arch ppc for example.
OSX_ARCH:=-arch $(shell uname -m | sed -e s/i.86/i386/)

# This will set the build options to create an MacOS .app-bundle.
# The app-bundle itself will not be created, but the runtime paths
# will be set to expect the game-data in *.app/
# Contents/Resources
OSX_APP:=yes

# This is an optional configuration file, it'll be used in
# case of presence.
CONFIG_FILE := config.mk

# ----------

# In case a of a configuration file being present, we'll just use it
ifeq ($(wildcard $(CONFIG_FILE)), $(CONFIG_FILE))
include $(CONFIG_FILE)
endif

# Detect the OS
ifdef SystemRoot
YQ2_OSTYPE := Windows
else
YQ2_OSTYPE ?= $(shell uname -s)
endif

# Special case for MinGW
ifneq (,$(findstring MINGW,$(YQ2_OSTYPE)))
YQ2_OSTYPE := Windows
endif

# Detect the architecture
ifeq ($(YQ2_OSTYPE), Windows)
ifdef PROCESSOR_ARCHITEW6432
# 64 bit Windows
YQ2_ARCH ?= $(PROCESSOR_ARCHITEW6432)
else
# 32 bit Windows
YQ2_ARCH ?= $(PROCESSOR_ARCHITECTURE)
endif
else
# Normalize some abiguous YQ2_ARCH strings
YQ2_ARCH ?= $(shell uname -m | sed -e 's/i.86/i386/' -e 's/amd64/x86_64/' -e 's/^arm.*/arm/')
endif

# Detect the compiler
ifeq ($(shell $(CC) -v 2>&1 | grep -c "clang version"), 1)
COMPILER := clang
else ifeq ($(shell $(CC) -v 2>&1 | grep -c "gcc version"), 1)
COMPILER := gcc
else
COMPILER := unknown
endif

# Used to detect libraries. Override to foobar-linux-gnu-pkg-config when
# cross-compiling.
PKG_CONFIG ?= pkg-config

# Disable CDA for SDL2
ifeq ($(WITH_SDL2),yes)
ifeq ($(WITH_CDA),yes)
WITH_CDA:=no

# Evil hack to tell the "all" target
# that CDA was disabled because SDL2
# is enabled.
CDA_DISABLED:=yes
endif
endif

# ----------

# Base CFLAGS.
#
# -O2 are enough optimizations.
#
# -fno-strict-aliasing since the source doesn't comply
#  with strict aliasing rules and it's next to impossible
#  to get it there...
#
# -fomit-frame-pointer since the framepointer is mostly
#  useless for debugging Quake II and slows things down.
#
# -g to build always with debug symbols. Please DO NOT
#  CHANGE THIS, since it's our only chance to debug this
#  crap when random crashes happen!
#
# -MMD to generate header dependencies. (They cannot be
#  generated if building universal binaries on OSX)
ifeq ($(YQ2_OSTYPE), Darwin)
CFLAGS := -O2 -fno-strict-aliasing -fomit-frame-pointer \
		  -Wall -pipe -g -fwrapv
CFLAGS += $(OSX_ARCH)
else
CFLAGS := -std=gnu99 -O2 -fno-strict-aliasing \
		  -Wall -pipe -g -ggdb -MMD -fwrapv
endif

# ----------

# Defines the operating system and architecture
CFLAGS += -DYQ2OSTYPE=\"$(YQ2_OSTYPE)\" -DYQ2ARCH=\"$(YQ2_ARCH)\"

# ----------

# https://reproducible-builds.org/specs/source-date-epoch/
ifdef SOURCE_DATE_EPOCH
CFLAGS += -DBUILD_DATE=\"$(shell date --utc --date="@${SOURCE_DATE_EPOCH}" +"%b %_d %Y" | sed -e 's/ /\\ /g')\"
endif

# ----------

# If we're building with gcc for i386 let's define -ffloat-store.
# This helps the old and crappy x87 FPU to produce correct values.
# Would be nice if Clang had something comparable.
ifeq ($(YQ2_ARCH), i386)
ifeq ($(COMPILER), gcc)
CFLAGS += -ffloat-store
endif
endif

# Force SSE math on x86_64. All sane compilers should do this
# anyway, just to protect us from broken Linux distros.
ifeq ($(YQ2_ARCH), x86_64)
CFLAGS += -mfpmath=sse
endif

# ----------

# Systemwide installation
ifeq ($(WITH_SYSTEMWIDE),yes)
CFLAGS += -DSYSTEMWIDE
ifneq ($(WITH_SYSTEMDIR),"")
CFLAGS += -DSYSTEMDIR=\"$(WITH_SYSTEMDIR)\"
endif
endif

# ----------

# On Windows / MinGW $(CC) is
# undefined by default.
ifeq ($(YQ2_OSTYPE),Windows)
CC := gcc
endif

# ----------

# Just set IOAPI_NO_64 on everything that's not Linux or Windows,
# otherwise minizip will use fopen64(), fseek64() and friends that
# may be unavailable. This is - of course - not really correct, in
# a better world we would set -DIOAPI_NO_64 to force everything to
# fopen(), fseek() and so on and -D_FILE_OFFSET_BITS=64 to let the
# libc headers do their work. Currently we can't do that because
# Quake II uses nearly everywere int instead of off_t...
#
# This may have the side effect that ZIP files larger than 2GB are
# unsupported. But I doubt that anyone has such large files, they
# would likely hit other internal limits.
ifneq ($(YQ2_OSTYPE),Windows)
ifneq ($(YQ2_OSTYPE),Linux)
ZIPCFLAGS += -DIOAPI_NO_64
endif
endif

# ----------

# Extra CFLAGS for SDL
ifeq ($(WITH_SDL2),yes)
SDLCFLAGS := $(shell sdl2-config --cflags)
else # not SDL2
SDLCFLAGS := $(shell sdl-config --cflags)
endif # SDL2

# ----------

# Extra CFLAGS for X11
ifneq ($(YQ2_OSTYPE), Windows)
ifneq ($(YQ2_OSTYPE), Darwin)
ifeq ($(WITH_X11GAMMA),yes)
X11CFLAGS := $(shell $(PKG_CONFIG) x11 --cflags)
X11CFLAGS += $(shell $(PKG_CONFIG) xxf86vm --cflags)
endif
endif
endif

# ----------

# Base include path.
ifeq ($(YQ2_OSTYPE),Linux)
INCLUDE := -I/usr/include
else ifeq ($(YQ2_OSTYPE),FreeBSD)
INCLUDE := -I/usr/local/include
else ifeq ($(YQ2_OSTYPE),OpenBSD)
INCLUDE := -I/usr/local/include
else ifeq ($(YQ2_OSTYPE),Windows)
INCLUDE := -I/usr/include
endif

# ----------

# Extra includes for GLAD
GLAD_INCLUDE = -Isrc/client/refresh/gl3/glad/include

# ----------

# Base LDFLAGS.
ifeq ($(YQ2_OSTYPE),Linux)
LDFLAGS := -L/usr/lib -lm -ldl -rdynamic
else ifeq ($(YQ2_OSTYPE),FreeBSD)
LDFLAGS := -L/usr/local/lib -lm
else ifeq ($(YQ2_OSTYPE),OpenBSD)
LDFLAGS := -L/usr/local/lib -lm
else ifeq ($(YQ2_OSTYPE),Windows)
LDFLAGS := -L/usr/lib -lws2_32 -lwinmm -static-libgcc
else ifeq ($(YQ2_OSTYPE), Darwin)
LDFLAGS := $(OSX_ARCH) -lm
endif

CFLAGS += -fvisibility=hidden
LDFLAGS += -fvisibility=hidden

ifneq ($(YQ2_OSTYPE), $(filter $(YQ2_OSTYPE), Darwin OpenBSD))
# for some reason the OSX & OpenBSD linker doesn't support this
LDFLAGS += -Wl,--no-undefined
endif

# ----------

# Extra LDFLAGS for SDL
ifeq ($(YQ2_OSTYPE), Darwin)
ifeq ($(WITH_SDL2),yes)
SDLLDFLAGS := -lSDL2
else # not SDL2
SDLLDFLAGS := -lSDL -framework OpenGL -framework Cocoa
endif # SDL2
else # not Darwin
ifeq ($(WITH_SDL2),yes)
SDLLDFLAGS := $(shell sdl2-config --libs)
else # not SDL2
SDLLDFLAGS := $(shell sdl-config --libs)
endif # SDL2
endif # Darwin

# ----------

# Extra LDFLAGS for X11
ifneq ($(YQ2_OSTYPE), Windows)
ifneq ($(YQ2_OSTYPE), Darwin)
ifeq ($(WITH_X11GAMMA),yes)
X11LDFLAGS := $(shell $(PKG_CONFIG) x11 --libs)
X11LDFLAGS += $(shell $(PKG_CONFIG) xxf86vm --libs)
X11LDFLAGS += $(shell $(PKG_CONFIG) xrandr --libs)
endif
endif
endif

# ----------

# When make is invoked by "make VERBOSE=1" print
# the compiler and linker commands.

ifdef VERBOSE
Q :=
else
Q := @
endif

# ----------

# Phony targets
.PHONY : all client game icon server ref_gl1 ref_gl3 ref_soft

# ----------

# Builds everything
all: config client server game ref_gl1 ref_gl3 ref_soft

# ----------

# Print config values
config:
	@echo "Build configuration"
	@echo "============================"
	@echo "WITH_CDA = $(WITH_CDA)"
	@echo "WITH_OPENAL = $(WITH_OPENAL)"
	@echo "WITH_SDL2 = $(WITH_SDL2)"
	@echo "WITH_X11GAMMA = $(WITH_X11GAMMA)"
	@echo "WITH_ZIP = $(WITH_ZIP)"
	@echo "WITH_SYSTEMWIDE = $(WITH_SYSTEMWIDE)"
	@echo "WITH_SYSTEMDIR = $(WITH_SYSTEMDIR)"
	@echo "============================"
	@echo ""
ifeq ($(WITH_SDL2),yes)
ifeq ($(CDA_DISABLED),yes)
	@echo "WARNING: CDA disabled because SDL2 doesn't support it!"
	@echo ""
endif
endif

# ----------

# Special target to compile
# the icon on Windows
ifeq ($(YQ2_OSTYPE), Windows)
icon:
	@echo "===> WR build/icon/icon.res"
	${Q}mkdir -p build/icon
	${Q}windres src/backends/windows/icon.rc -O COFF -o build/icon/icon.res
endif

# ----------

# Cleanup
clean:
	@echo "===> CLEAN"
	${Q}rm -Rf build release/*

cleanall:
	@echo "===> CLEAN"
	${Q}rm -Rf build release

# ----------

# The client
ifeq ($(YQ2_OSTYPE), Windows)
client:
	@echo "===> Building yquake2.exe"
	${Q}mkdir -p release
	$(MAKE) release/yquake2.exe
	@echo "===> Building quake2.exe Wrapper"
	$(MAKE) release/quake2.exe

build/client/%.o: %.c
	@echo "===> CC $<"
	${Q}mkdir -p $(@D)
	${Q}$(CC) -c $(CFLAGS) $(SDLCFLAGS) $(INCLUDE) -o $@ $<

ifeq ($(WITH_CDA),yes)
release/yquake2.exe : CFLAGS += -DCDA
endif

ifeq ($(WITH_OGG),yes)
release/yquake2.exe : CFLAGS += -DOGG
release/yquake2.exe : LDFLAGS += -lvorbisfile -lvorbis -logg
endif

ifeq ($(WITH_OPENAL),yes)
release/yquake2.exe : CFLAGS += -DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER='"openal32.dll"' -DDLOPEN_OPENAL
endif

ifeq ($(WITH_ZIP),yes)
release/yquake2.exe : CFLAGS += -DZIP -DNOUNCRYPT
release/yquake2.exe : LDFLAGS += -lz
endif

ifeq ($(WITH_SDL2),yes)
release/yquake2.exe : CFLAGS += -DSDL2
endif

release/yquake2.exe : LDFLAGS += -mwindows

else # not Windows

client:
	@echo "===> Building quake2"
	${Q}mkdir -p release

=== debian/changelog ===
yquake2 (7.21+ctf1.05~dfsg-1) unstable; urgency=medium

  * d/README.source: Add a note about how to update to new upstream releases
  * New upstream release
  * Refresh patches
    - d/p/Make-uses-of-pkg-config-cross-compilation-friendly.patch:
      drop, applied upstream
  * ctf-Use-SOURCE_DATE_EPOCH-for-reproducible-build.patch,
    Link-ctf-game.so-to-math-library.patch,
    Fix-some-spelling-mistakes-detected-by-Debian-s-Lintian-t.patch:
    Mark some CTF patches as forwarded upstream
  * d/p/Fix-segfault-in-OGG_PlayTrack-when-ogg_enable-is-set-to-z.patch:
    Add post-release fix for a segfault with non-default configuration
  * Standards-Version: 4.1.5 (no changes required)
  * d/p/Fix-spelling-of-information-and-re-word-a-comment-with-mu.patch:
    Fix more spellings flagged by Lintian

 -- Simon McVittie <smcv@debian.org>  Sat, 21 Jul 2018 12:07:17 +0100

yquake2 (7.20+ctf1.05~dfsg-2) unstable; urgency=medium

  * d/p/Make-uses-of-pkg-config-cross-compilation-friendly.patch:
    Use $(PKG_CONFIG) so that cross-compilation can use an
    appropriately-prefixed pkg-config
  * d/rules: Explicitly set YQ2ARCH and YQ2OSTYPE instead of letting
    the Makefile use uname -m and uname -s, for cross-compilation
  * Note that cross-compilation requires a multiarch libopusfile-dev
    (see #899138)

 -- Simon McVittie <smcv@debian.org>  Tue, 12 Jun 2018 11:37:31 +0100

yquake2 (7.20+ctf1.05~dfsg-1) unstable; urgency=medium

  * New upstream release
  * d/copyright: Update
  * Refresh patch series
  * Fix-a-potential-crash-in-ai_run_melee-and-ai_run_missile.patch:
    Apply a bugfix patch from upstream CTF module

 -- Simon McVittie <smcv@debian.org>  Sun, 11 Mar 2018 21:43:17 +0000

=== debian/control ===
Source: yquake2
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Fabian Greffrath <fabian@debian.org>,
 Simon McVittie <smcv@debian.org>
Build-Depends:
 debhelper (>= 10),
 libgl1-mesa-dev | libgl-dev,
 libopenal-dev,
 libsdl2-dev,
 libvorbis-dev,
 libxrandr-dev,
 libxxf86vm-dev,
 zlib1g-dev
Rules-Requires-Root: no
Standards-Version: 4.1.5
Homepage: https://www.yamagi.org/quake2/
Vcs-Git: https://salsa.debian.org/games-team/yquake2.git
Vcs-Browser: https://salsa.debian.org/games-team/yquake2

Package: yamagi-quake2
Architecture: linux-any
Depends:
 yamagi-quake2-core (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Recommends: quake2
Provides: quake2-engine
Description: enhanced version of id Software's Quake II - client
 This is the Yamagi Quake II Client, an enhanced Version of id Software's
 Quake II. The main focus is single player, the gameplay and the graphics are
 unchanged, but many bugs were fixed. This code is based upon Icculus Quake II,
 which itself is built upon id Software's original code drop. Additional code
 and patches by many contributors were used.
 .
 This engine is intended to be used via the wrapper script and menu entries
 in the quake2 package.

Package: yamagi-quake2-core
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends: quake2-server | yamagi-quake2
Provides: quake2-engine-server
Breaks: yamagi-quake2 (<< 5.11)
Replaces: yamagi-quake2 (<< 5.11)
Description: enhanced version of id Software's Quake II - non-GUI part
 This is the Yamagi Quake II Server, an enhanced Version of id Software's
 Quake II. This code is based upon Icculus Quake II,
 which itself is built upon id Software's original code drop. Additional code
 and patches by many contributors were used.
 .
 This package contains files common to the client and the server, and a
 dedicated server engine is intended to be used via the wrapper script
 and init scripts in the quake2-server package.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export LC_ALL=C.UTF-8
export TZ=UTC

DEB_LDFLAGS_MAINT_APPEND  += -Wl,--as-needed -Wl,-z,defs
export DEB_CPPFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_APPEND

%:
	dh $@

export LC_ALL=C.UTF-8
export TZ=UTC

# YQ2_ARCH is meant to be uname -m, except that i?86, amd64 and arm*
# are normalized to i386, x86_64 and arm respectively; the value matters,
# because it appears in saved games. Newer CPU architectures tend to have
# the GNU CPU name be the same as the Linux uname -m, because anything
# else would be pointless complication.
ifeq ($(DEB_HOST_ARCH_CPU),i386)
# Don't use i686 here
YQ2_ARCH=i386
else ifeq ($(DEB_HOST_ARCH_CPU),powerpc)
# Linux and GNU disagree on the canonical name of this architecture
YQ2_ARCH=ppc
else
# This is the same as uname -m on most architectures. On ARM it's just
# "arm" which is what we wanted anyway.
YQ2_ARCH=$(DEB_HOST_GNU_CPU)
endif

# Similarly, YQ2_OSTYPE is meant to be uname -s.
ifeq ($(DEB_HOST_ARCH_OS),linux)
YQ2_OSTYPE=Linux
else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
YQ2_OSTYPE=GNU/kFreeBSD
else ifeq ($(DEB_HOST_ARCH_OS),hurd)
YQ2_OSTYPE=GNU
else
$(error Set YQ2_OSTYPE to the value of uname -s on $(DEB_HOST_ARCH))
endif

override_dh_auto_build:
	dh_auto_build -- \
		DLOPEN_LIBGL=no \
		DLOPEN_OPENAL=no \
		VERBOSE=1 \
		WITH_SYSTEMWIDE=yes \
		WITH_X11GAMMA=yes \
		YQ2_ARCH=$(DEB_HOST_ARCH_CPU) \
		YQ2_OSTYPE=$(YQ2_OSTYPE) \
		${NULL}
	dh_auto_build --sourcedirectory=ctf -- \
		VERBOSE=1

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG

override_dh_installdocs:
	dh_installdocs CONTRIBUTE README.md

## yquake2 7.40%2Bctf1.06~dfsg

=== debian/changelog ===
yquake2 (7.40+ctf1.06~dfsg-1) unstable; urgency=medium

  * New upstream release
    - Refresh patch series
    - Build-Depend on libcurl-dev
    - Install new documentation
  * Standards-Version: 4.3.0 (no changes required)
  * Add Depends on libgl1, loaded via dlopen()
  * Add Recommends on libopenal1, loaded via dlopen() as the preferred
    audio backend (plain SDL is also possible)
  * Add Suggests on various flavours of libcurl, optionally used for
    download redirection

 -- Simon McVittie <smcv@debian.org>  Sun, 10 Feb 2019 15:47:17 +0000

yquake2 (7.30+ctf1.05~dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Simon McVittie ]
  * Revert "Update maintainer address".
    The lists.alioth.debian.org form is still canonical.

  [ Bruno "Fuddl" Kleinert ]
  * Fix broken symlink: /usr/share/doc/yamagi-quake2/NEWS ->
    ../yamagi-quake2-core/NEWS (Closes: #915867)

 -- Bruno "Fuddl" Kleinert <fuddl@debian.org>  Sat, 08 Dec 2018 10:34:14 +0100

yquake2 (7.30+ctf1.05~dfsg-1) unstable; urgency=medium

  * Update maintainer address
  * New upstream release
    - d/copyright: Update
  * Install upstream CHANGELOG (which is actually just release notes) to
    /usr/share/doc/package/NEWS.gz as recommended by Policy §12.7
  * Standards-Version: 4.2.1 (no further changes required)
  * Refresh patches
    - d/p/Fix-segfault-in-OGG_PlayTrack-when-ogg_enable-is-set-to-z.patch,
      d/p/Fix-spelling-of-information-and-re-word-a-comment-with-mu.patch:
      Drop, applied upstream

 -- Simon McVittie <smcv@debian.org>  Sat, 08 Sep 2018 17:07:03 +0100

## yquake2 7.40+ctf1.06~dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,14 @@
 cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
 
-# Enforce "Debug" as standard build type
+# Enforce "Debug" as standard build type.
 if(NOT CMAKE_BUILD_TYPE)
 	set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
 endif()
 
-# CMake project configuration
+# CMake project configuration.
 project(yquake2)
 
-# Cmake module search path
+# Cmake module search path.
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/stuff/cmake/modules ${CMAKE_MODULE_PATH})
 
 if(YQUAKE2LIBS)
@@ -19,30 +19,36 @@
 	endif()
 
 	set(ENV{OPENALDIR} ${YQUAKE2LIBS})
-	set(ENV{SDLDIR} ${YQUAKE2LIBS})
 	set(ENV{SDL2DIR} ${YQUAKE2LIBS})
 endif()
 
-# Add extended path for FreeBSD and Homebrew on OS X
+# Add extended path for FreeBSD and Homebrew on OS X.
 list(APPEND CMAKE_PREFIX_PATH /usr/local)
 
-# Enforce compiler flags (GCC / Clang compatible, yquake2
-# won't build with another compiler anyways)
+# Enforce compiler flags:
 #  -Wall                -> More warnings
 #  -fno-strict-aliasing -> Quake 2 is far away from strict aliasing
 #  -fwrapv              -> Make signed integer overflows defined
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -fno-strict-aliasing -fwrapv")
 
+# Switch of some annoying warnings
+if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-missing-braces")
+elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
+	if (CMAKE_CXX_COMPILER_VERSION GREATER 7.99)
+		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-format-truncation -Wno-format-overflow")
+	endif()
+endif()
+
 # Use -O2 as maximum optimization level. -O3 has it's problems with yquake2.
 string(REPLACE "-O3" "-O2" CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
 
-# yquake2 compilation options
-option(ZIP_SUPPORT "ZIP support" ON)
-option(OGG_SUPPORT "OGG Vorbis playback support (Music)" ON)
+# Compilation time options.
+option(CURL_SUPPORT "cURL support" ON)
 option(OPENAL_SUPPORT "OpenAL support" ON)
 option(SYSTEMWIDE_SUPPORT "Enable systemwide installation of game assets" OFF)
 
-# These variables will act as our list of include folders and linker flags
+# These variables will act as our list of include folders and linker flags.
 set(yquake2IncludeDirectories)
 set(yquake2LinkerDirectories)
 set(yquake2LinkerFlags)
@@ -61,74 +67,60 @@
 set(CLIENT_SRC_DIR ${SOURCE_DIR}/client)
 set(REF_SRC_DIR ${SOURCE_DIR}/client/refresh)
 
-# Operating system
+# Operating system.
 set(YQ2OSTYPE "${CMAKE_SYSTEM_NAME}" CACHE STRING "Override operation system type")
 add_definitions(-DYQ2OSTYPE="${YQ2OSTYPE}")
 
-# Architecture string
+# Architecture string.
 set(YQ2ARCH "${CMAKE_SYSTEM_PROCESSOR}" CACHE STRING "Override CPU architecture")
 string(REGEX REPLACE "amd64" "x86_64" ARCH ${YQ2ARCH})
 string(REGEX REPLACE "i.86" "i386" ARCH ${ARCH})
 string(REGEX REPLACE "^arm.*" "arm" ARCH ${ARCH})
 add_definitions(-DYQ2ARCH="${ARCH}")
 
-# Systemwide installation of game assets
+# Systemwide installation of game assets.
 if(${SYSTEMWIDE_SUPPORT})
     add_definitions(-DSYSTEMWIDE)
 endif()
 
+# We need to pass some options to minizip / unzip.
+add_definitions(-DNOUNCRYPT)
+
+if(NOT CMAKE_SYSTEM_NAME MATCHES "Linux" OR NOT CMAKE_SYSTEM_NAME MATCHES "Windows")
+	add_definitions(-DIOAPI_NO_64)
+endif()
+
 # Required libraries to build the different components of the binaries. Find
 # them and add the include/linker directories and flags (in case the package
-# manager find it in a weird place)
-find_package(SDL2)
-if(${SDL2_FOUND})
-	add_definitions(-DSDL2)
-	list(APPEND yquake2IncludeDirectories "${SDL2_INCLUDE_DIR}/..")
-	list(APPEND yquake2SDLLinkerFlags ${SDL2_LIBRARY})
-else()
-	find_package(SDL REQUIRED)
-	add_definitions(-DWITH_CDA)
-	list(APPEND yquake2IncludeDirectories "${SDL_INCLUDE_DIR}/..")
-	list(APPEND yquake2SDLLinkerFlags ${SDL_LIBRARY})
-endif()
-
+# manager find it in a weird place).
+find_package(SDL2 REQUIRED)
+list(APPEND yquake2IncludeDirectories "${SDL2_INCLUDE_DIR}/..")
+list(APPEND yquake2SDLLinkerFlags ${SDL2_LIBRARY})
+
+# We need an OpenGL implementation.
+set(OpenGL_GL_PREFERENCE GLVND)
 find_package(OpenGL REQUIRED)
 list(APPEND yquake2IncludeDirectories ${OPENGL_INCLUDE_DIR})
 list(APPEND yquake2OpenGLLinkerFlags ${OPENGL_LIBRARIES})
 
+# FreeBSD needs libexecinfo.
 if(${CMAKE_HOST_SYSTEM_NAME} STREQUAL "FreeBSD")
 	find_library(EXECINFO_LIBRARIES execinfo /usr/lib /usr/local/lib)
 	list(APPEND yquake2ClientLinkerFlags ${EXECINFO_LIBRARIES})
 	list(APPEND yquake2ServerLinkerFlags ${EXECINFO_LIBRARIES})
 endif()
 
-
-
-if(${ZIP_SUPPORT})
-	find_package(ZLIB REQUIRED)
-	list(APPEND yquake2IncludeDirectories ${ZLIB_INCLUDE_DIRS})
-	list(APPEND yquake2ZLibLinkerFlags ${ZLIB_LIBRARIES})
-	add_definitions(-DZIP -DNOUNCRYPT)
-
-	if(NOT CMAKE_SYSTEM_NAME MATCHES "Linux" OR NOT CMAKE_SYSTEM_NAME MATCHES "Windows")
-		add_definitions(-DIOAPI_NO_64)
-	endif()
-endif()
-
-if(${OGG_SUPPORT})
-	find_package(OggVorbis)
-	if(${OGGVORBIS_FOUND})
-		add_definitions(-DOGG)
-		list(APPEND yquake2IncludeDirectories ${VORBIS_INCLUDE_DIR})
-		list(APPEND yquake2ClientLinkerFlags ${OGG_LIBRARY} ${VORBIS_LIBRARY} ${VORBISFILE_LIBRARY})
-	endif()
-endif()
-
+# cURL support.
+if (${CURL_SUPPORT})
+	find_package(CURL REQUIRED)
+	add_definitions(-DUSE_CURL)
+endif()
+
+# OpenAL support.
 if(${OPENAL_SUPPORT})
 	find_package(OpenAL)
 
-	# TODO: OS X is still missing here
-	if(${OPENAL_FOUND} AND NOT(${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
+	if(${OPENAL_FOUND})
 		list(APPEND yquake2IncludeDirectories "${OPENAL_INCLUDE_DIR}")
 		list(APPEND yquake2ClientLinkerFlags ${OPENAL_LIBRARY})
 
@@ -144,6 +136,7 @@
 	endif()
 endif()
 
+# General linker flags.
 if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
 	list(APPEND yquake2LinkerFlags "-lm -static-libgcc")
 else()
@@ -174,22 +167,9 @@
 
 set(Backends-Generic-Source
 	${BACKENDS_SRC_DIR}/generic/misc.c
-	${BACKENDS_SRC_DIR}/generic/qal.c
-	${BACKENDS_SRC_DIR}/generic/vid.c
-
-	${BACKENDS_SRC_DIR}/sdl/cd.c
-	${BACKENDS_SRC_DIR}/sdl/input.c
-	${BACKENDS_SRC_DIR}/sdl/refresh.c
-	${BACKENDS_SRC_DIR}/sdl/sound.c
-	)
-
-set(Backends-Generic-Header
-	${BACKENDS_SRC_DIR}/generic/header/input.h
-	${BACKENDS_SRC_DIR}/generic/header/qal.h
 	)
 
 set(Backends-Unix-Source
-	${BACKENDS_SRC_DIR}/generic/misc.c
 	${BACKENDS_SRC_DIR}/unix/main.c
 	${BACKENDS_SRC_DIR}/unix/network.c
 	${BACKENDS_SRC_DIR}/unix/signalhandler.c
@@ -329,13 +309,20 @@
 	${CLIENT_SRC_DIR}/cl_screen.c
 	${CLIENT_SRC_DIR}/cl_tempentities.c
 	${CLIENT_SRC_DIR}/cl_view.c
+	${CLIENT_SRC_DIR}/curl/download.c
+	${CLIENT_SRC_DIR}/curl/qcurl.c
+	${CLIENT_SRC_DIR}/input/sdl.c
 	${CLIENT_SRC_DIR}/menu/menu.c
 	${CLIENT_SRC_DIR}/menu/qmenu.c
 	${CLIENT_SRC_DIR}/menu/videomenu.c
 	${CLIENT_SRC_DIR}/sound/ogg.c
 	${CLIENT_SRC_DIR}/sound/openal.c
+	${CLIENT_SRC_DIR}/sound/qal.c
+	${CLIENT_SRC_DIR}/sound/sdl.c
 	${CLIENT_SRC_DIR}/sound/sound.c
 	${CLIENT_SRC_DIR}/sound/wave.c
+	${CLIENT_SRC_DIR}/vid/glimp_sdl.c
+	${CLIENT_SRC_DIR}/vid/vid.c
 	${COMMON_SRC_DIR}/argproc.c
 	${COMMON_SRC_DIR}/clientserver.c
 	${COMMON_SRC_DIR}/collision.c
@@ -355,5 +342,20 @@
 	${COMMON_SRC_DIR}/shared/rand.c
 	${COMMON_SRC_DIR}/shared/shared.c
 	${COMMON_SRC_DIR}/unzip/ioapi.c
+	${COMMON_SRC_DIR}/unzip/miniz.c
 	${COMMON_SRC_DIR}/unzip/unzip.c
 	${SERVER_SRC_DIR}/sv_cmd.c
+	${SERVER_SRC_DIR}/sv_conless.c
+	${SERVER_SRC_DIR}/sv_entities.c
+	${SERVER_SRC_DIR}/sv_game.c
+	${SERVER_SRC_DIR}/sv_init.c
+	${SERVER_SRC_DIR}/sv_main.c
+	${SERVER_SRC_DIR}/sv_save.c
+	${SERVER_SRC_DIR}/sv_send.c
+	${SERVER_SRC_DIR}/sv_user.c
+	${SERVER_SRC_DIR}/sv_world.c
+	)
+
+set(Client-Header
+	${CLIENT_SRC_DIR}/header/client.h
+	${CLIENT_SRC_DIR}/header/console.h

=== Makefile ===
# ----------------------------------------------------- #
# Makefile for the CTF game module for Quake II         #
#                                                       #
# Just type "make" to compile the                       #
#  - CTF Game (game.so / game.dll)                      #
#                                                       #
# Dependencies:                                         #
# - None, but you need a Quake II to play.              #
#   While in theorie every one should work              #
#   Yamagi Quake II ist recommended.                    #
#                                                       #
# Platforms:                                            #
# - FreeBSD                                             #
# - Linux                                               #
# - Mac OS X                                            #
# - OpenBSD                                             #
# - Windows                                             # 
# ----------------------------------------------------- #

# Detect the OS
ifdef SystemRoot
OSTYPE := Windows
else
OSTYPE := $(shell uname -s)
endif
 
# Special case for MinGW
ifneq (,$(findstring MINGW,$(OSTYPE)))
OSTYPE := Windows
endif

# On Windows / MinGW $(CC) is undefined by default.
ifeq ($(YQ2_OSTYPE),Windows)
CC := gcc
endif

# Detect the compiler
ifeq ($(shell $(CC) -v 2>&1 | grep -c "clang version"), 1)
COMPILER := clang
COMPILERVER := $(shell $(CC)  -dumpversion | sed -e 's/\.\([0-9][0-9]\)/\1/g' -e 's/\.\([0-9]\)/0\1/g' -e 's/^[0-9]\{3,4\}$$/&00/')
else ifeq ($(shell $(CC) -v 2>&1 | grep -c -E "(gcc version|gcc-Version)"), 1)
COMPILER := gcc
COMPILERVER := $(shell $(CC)  -dumpversion | sed -e 's/\.\([0-9][0-9]\)/\1/g' -e 's/\.\([0-9]\)/0\1/g' -e 's/^[0-9]\{3,4\}$$/&00/')
else
COMPILER := unknown
endif

# ----------

# Base CFLAGS. 
#
# -O2 are enough optimizations.
# 
# -fno-strict-aliasing since the source doesn't comply
#  with strict aliasing rules and it's next to impossible
#  to get it there...
#
# -fomit-frame-pointer since the framepointer is mostly
#  useless for debugging Quake II and slows things down.
#
# -g to build allways with debug symbols. Please do not
#  change this, since it's our only chance to debug this
#  crap when random crashes happen!
#
# -fPIC for position independend code.
#
# -MMD to generate header dependencies.
ifeq ($(OSTYPE), Darwin)
CFLAGS := -O2 -fno-strict-aliasing -fomit-frame-pointer \
		  -Wall -pipe -g -fwrapv -arch i386 -arch x86_64
else
CFLAGS := -O2 -fno-strict-aliasing -fomit-frame-pointer \
		  -Wall -pipe -g -MMD -fwrapv
endif

# ----------

# Switch of some annoying warnings.
ifeq ($(COMPILER), clang)
	# -Wno-missing-braces because otherwise clang complains
	#  about totally valid 'vec3_t bla = {0}' constructs.
	CFLAGS += -Wno-missing-braces
else ifeq ($(COMPILER), gcc)
	# GCC 8.0 or higher.
	ifeq ($(shell test $(COMPILERVER) -ge 80000; echo $$?),0)
	    # -Wno-format-truncation and -Wno-format-overflow
		# because GCC spams about 50 false positives.
    	CFLAGS += -Wno-format-truncation -Wno-format-overflow
	endif
endif

# ----------

# Base LDFLAGS.
ifeq ($(OSTYPE), Darwin)
LDFLAGS := -shared -arch i386 -arch x86_64 
else ifeq ($(OSTYPE), Windows)
LDFLAGS := -shared -static-libgcc
else
LDFLAGS := -shared
endif

# ----------

# Builds everything
all: ctf

# ----------
 
# When make is invoked by "make VERBOSE=1" print
# the compiler and linker commands.

ifdef VERBOSE
Q :=
else
Q := @
endif

# ----------

# Phony targets
.PHONY : all clean ctf

# ----------
 
# Cleanup
clean:
	@echo "===> CLEAN"
	${Q}rm -Rf build release
 
# ----------

# The ctf game
ifeq ($(OSTYPE), Windows)
ctf:
	@echo "===> Building game.dll"
	$(Q)mkdir -p release
	$(MAKE) release/game.dll

build/%.o: %.c
	@echo "===> CC $<"
	$(Q)mkdir -p $(@D)
	$(Q)$(CC) -c $(CFLAGS) -o $@ $<
else
ctf:
	@echo "===> Building game.so"
	$(Q)mkdir -p release
	$(MAKE) release/game.so

build/%.o: %.c
	@echo "===> CC $<"
	$(Q)mkdir -p $(@D)
	$(Q)$(CC) -c $(CFLAGS) -o $@ $<

release/game.so : CFLAGS += -fPIC
endif
 
# ----------

CTF_OBJS_ = \
	src/g_ai.o \
	src/g_chase.o \
	src/g_cmds.o \
	src/g_combat.o \
	src/g_ctf.o \
	src/g_func.o \
	src/g_items.o \
	src/g_main.o \
	src/g_misc.o \
	src/g_monster.o \
	src/g_phys.o \
	src/g_save.o \
	src/g_spawn.o \
	src/g_svcmds.o \
	src/g_target.o \
	src/g_trigger.o \
	src/g_utils.o \
	src/g_weapon.o \
	src/menu/menu.o \
	src/monster/move.o \
	src/player/client.o \
	src/player/hud.o \
	src/player/trail.o \
	src/player/view.o \
	src/player/weapon.o \
	src/shared/shared.o 

# ----------

# Rewrite pathes to our object directory
CTF_OBJS = $(patsubst %,build/%,$(CTF_OBJS_))

# ----------

# Generate header dependencies
CTF_DEPS= $(CTF_OBJS:.o=.d)

# ----------

# Suck header dependencies in
-include $(CTF_DEPS)

# ----------

ifeq ($(OSTYPE), Windows)
release/game.dll : $(CTF_OBJS)
	@echo "===> LD $@"
	$(Q)$(CC) $(LDFLAGS) -o $@ $(CTF_OBJS)
release/game.dylib : $(CTF_OBJS)
	@echo "===> LD $@"
	${Q}$(CC) $(LDFLAGS) -o $@ $(CTF_OBJS)
else
release/game.so : $(CTF_OBJS)
	@echo "===> LD $@"
	$(Q)$(CC) $(LDFLAGS) -o $@ $(CTF_OBJS)
endif
 
# ----------

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
  Simon McVittie <smcv@debian.org>
 Build-Depends:
  debhelper (>= 10),
+ libcurl4-gnutls-dev | libcurl-dev,
  libgl1-mesa-dev | libgl-dev,
  libopenal-dev,
  libsdl2-dev,
@@ -15,7 +16,7 @@
  libxxf86vm-dev,
  zlib1g-dev
 Rules-Requires-Root: no
-Standards-Version: 4.1.5
+Standards-Version: 4.3.0
 Homepage: https://www.yamagi.org/quake2/
 Vcs-Git: https://salsa.debian.org/games-team/yquake2.git
 Vcs-Browser: https://salsa.debian.org/games-team/yquake2
@@ -23,10 +24,15 @@
 Package: yamagi-quake2
 Architecture: linux-any
 Depends:
+ libgl1,
  yamagi-quake2-core (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends}
-Recommends: quake2
+Recommends:
+ libopenal1,
+ quake2,
+Suggests:
+ libcurl3-gnutls | libcurl4 | libcurl3-nss | libcurl3,
 Provides: quake2-engine
 Description: enhanced version of id Software's Quake II - client
  This is the Yamagi Quake II Client, an enhanced Version of id Software's

## yquake2 7.41+ctf1.06~dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -178,7 +178,6 @@
 	)
 
 set(Backends-Windows-Source
-	${BACKENDS_SRC_DIR}/generic/frame.c
 	${BACKENDS_SRC_DIR}/windows/icon.rc
 	${BACKENDS_SRC_DIR}/windows/main.c
 	${BACKENDS_SRC_DIR}/windows/network.c
@@ -359,3 +358,4 @@
 set(Client-Header
 	${CLIENT_SRC_DIR}/header/client.h
 	${CLIENT_SRC_DIR}/header/console.h
+	${CLIENT_SRC_DIR}/header/keyboard.h

=== debian/changelog ===
yquake2 (7.41+ctf1.06~dfsg-2) unstable; urgency=medium

  * Upload to unstable
  * d/salsa-ci.yml: Request standard CI on salsa.debian.org
  * Standards-Version: 4.4.0 (no changes required)
  * Use debhelper-compat 12

 -- Simon McVittie <smcv@debian.org>  Tue, 09 Jul 2019 17:15:47 +0100

yquake2 (7.41+ctf1.06~dfsg-1) experimental; urgency=medium

  * New upstream release

 -- Simon McVittie <smcv@debian.org>  Wed, 12 Jun 2019 22:00:28 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Fabian Greffrath <fabian@debian.org>,
  Simon McVittie <smcv@debian.org>
 Build-Depends:
- debhelper (>= 10),
+ debhelper-compat (= 12),
  libcurl4-gnutls-dev | libcurl-dev,
  libgl1-mesa-dev | libgl-dev,
  libopenal-dev,
@@ -16,7 +16,7 @@
  libxxf86vm-dev,
  zlib1g-dev
 Rules-Requires-Root: no
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://www.yamagi.org/quake2/
 Vcs-Git: https://salsa.debian.org/games-team/yquake2.git
 Vcs-Browser: https://salsa.debian.org/games-team/yquake2

## yquake2 7.42%2Bctf1.06~dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -73,9 +73,9 @@
 
 # Architecture string.
 set(YQ2ARCH "${CMAKE_SYSTEM_PROCESSOR}" CACHE STRING "Override CPU architecture")
-string(REGEX REPLACE "amd64" "x86_64" ARCH ${YQ2ARCH})
-string(REGEX REPLACE "i.86" "i386" ARCH ${ARCH})
-string(REGEX REPLACE "^arm.*" "arm" ARCH ${ARCH})
+string(REGEX REPLACE "amd64" "x86_64" ARCH "${YQ2ARCH}")
+string(REGEX REPLACE "i.86" "i386" ARCH "${ARCH}")
+string(REGEX REPLACE "^arm.*" "arm" ARCH "${ARCH}")
 add_definitions(-DYQ2ARCH="${ARCH}")
 
 # Systemwide installation of game assets.

=== debian/changelog ===
yquake2 (7.42+ctf1.06~dfsg-1) unstable; urgency=medium

  * Standards-Version: 4.4.1 (no changes required)
  * New upstream release

 -- Simon McVittie <smcv@debian.org>  Sun, 22 Dec 2019 22:05:13 +0000

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
  libxxf86vm-dev,
  zlib1g-dev
 Rules-Requires-Root: no
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Homepage: https://www.yamagi.org/quake2/
 Vcs-Git: https://salsa.debian.org/games-team/yquake2.git
 Vcs-Browser: https://salsa.debian.org/games-team/yquake2
